#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <inttypes.h>
#include <stdlib.h>

uint32_t read_32_be(unsigned char *b)
{
    uint32_t t = 0;
    for (int i = 0; i < 4; i++)
    {
        t *= 0x100;
        t += b[i];
    }

    return t;
}

int main(int argc, char **argv)
{
    if (argc != 5) exit(EXIT_FAILURE);
    
    FILE *infile = fopen(argv[1], "rb");
    if (!infile) exit(EXIT_FAILURE);

    FILE *outfile[3];
    
    for (unsigned int i = 0; i < 3; i ++)
    {
        outfile[i] = fopen(argv[2+i], "wb");
        if (!outfile[i]) exit(EXIT_FAILURE);
    }

    unsigned char head_buf[8];
    unsigned char buf[0x800];

    int done = 0;

    while (!done)
    {
        if ( fread(head_buf, 1, 8, infile) != 8) exit(EXIT_FAILURE);

        if ((head_buf[0] & 0x80) == 0x80)
        {
            done = 1;
            head_buf[0] &= ~0x80;
        }

        uint32_t block_size = read_32_be(&head_buf[0]);
        if (block_size < 8) exit(EXIT_FAILURE);

        for (unsigned int substream = 0; substream < 3; substream ++)
        {
            unsigned char subhead_buf[4];
            if ( fread(subhead_buf, 1, 4, infile) != 4) exit(EXIT_FAILURE);

            uint32_t pseudo_size = read_32_be(&subhead_buf[0]);
            uint32_t subblock_size = pseudo_size / 4 - 4;   /* this value has rounding built in */

            while (subblock_size >= 0x800)
            {
                if (fread(buf, 1, 0x800, infile) != 0x800) exit(EXIT_FAILURE);
                if (fwrite(buf, 1, 0x800, outfile[substream]) != 0x800) exit(EXIT_FAILURE);
                subblock_size -= 0x800;
            }

            if (subblock_size > 0)
            {
                memset(buf,0xff,sizeof(buf));
                //memset(buf,0,sizeof(buf));
                if (fread(buf, 1, subblock_size, infile) != subblock_size) exit(EXIT_FAILURE);
                if (fwrite(buf, 1, 0x800, outfile[substream]) != 0x800) exit(EXIT_FAILURE);
            }
        }
    }

    printf("Done!\n");

    return 0;
}
